package com.example.survey.util;

import com.deepoove.poi.XWPFTemplate;
import com.deepoove.poi.config.Configure;
import com.deepoove.poi.config.ConfigureBuilder;
import com.deepoove.poi.policy.HackLoopTableRenderPolicy;

import javax.servlet.http.HttpServletResponse;
import java.io.BufferedOutputStream;
import java.io.IOException;
import java.util.List;
import java.util.Map;
import java.util.UUID;

/**
 * @author Pope
 */
public class WordUtil {
    public static void export2word(HttpServletResponse response, Map<String, Object> values, String templatePath) {

        response.addHeader("Content-Disposition", "attachment;filename=" + UUID.randomUUID().toString() + ".docx");

        ConfigureBuilder configureBuilder = Configure.builder();
        HackLoopTableRenderPolicy policy = new HackLoopTableRenderPolicy();
        for (String key : values.keySet()) {
            Object value = values.get(key);
            if (value instanceof List) {
                List<Object> newValue = (List<Object>) value;
                if(newValue.size()==0){
                    continue;
                }
                Object o = newValue.get(0);
                if (o instanceof String) {
                    StringBuilder sb = new StringBuilder();
                    newValue.forEach(str -> {
                        sb.append(str + " ");
                    });
                    values.put(key, sb.toString());
                } else {
                    configureBuilder = configureBuilder.bind(key, policy);
                }
            }
        }
        XWPFTemplate template = XWPFTemplate.compile(templatePath, configureBuilder.build()).render(values);
        try (BufferedOutputStream os = new BufferedOutputStream(response.getOutputStream())) {
            template.write(os);
        } catch (IOException e) {
            e.printStackTrace();
        } finally {
            try {
                template.close();
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
    }
}
